/*
 * Ubiquity REST API
 * Ubiquity provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar * dogecoin * oasis * stacks * near  #### Testnet * bitcoin/testnet * ethereum/ropsten * dogecoin/testnet  #### Native Ubiquity provides native access to all Blockchain nodes it supports. To access native functionality, use the protocol without the v2 prefix * bitcoin/(mainnet | testnet) - [RPC Documentation](https://developer.bitcoin.org/reference/rpc/) * ethereum/(mainnet | ropsten) - [RPC Documentation](https://ethereum.org/en/developers/docs/apis/json-rpc/) * polkadot/mainnet - [Sidecar API Documentation](https://paritytech.github.io/substrate-api-sidecar/dist/) * polkadot/mainnet/http-rpc - [Polkadot RPC Documentation](https://polkadot.js.org/docs/substrate/rpc/) * algorand/mainnet - [Algod API Documentation](https://developer.algorand.org/docs/reference/rest-apis/algod/v1/) * stellar/mainnet - [Stellar Horizon API Documentation](https://developers.stellar.org/api) * dogecoin/(mainnet | testnet) - [Dogecoin API Documentaion](https://developer.bitcoin.org/reference/rpc/) * oasis/mainnet - [Oasis Rosetta Gateway Documentation](https://www.rosetta-api.org/docs/api_identifiers.html#network-identifier) * stacks/mainnet - [Stacks API Documentation](https://blockstack.github.io/stacks-blockchain-api/) * near/mainnet - [NEAR RPC Documentation](https://docs.near.org/docs/api/rpc)  A full URL example: https://ubiquity.api.blockdaemon.com/_**bitcoin/mainnet**  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available. 
 *
 * The version of the OpenAPI document: 2.0.0
 * Contact: support@blockdaemon.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.gitlab.blockdaemon.ubiquity.api;

import com.gitlab.blockdaemon.ubiquity.invoker.ApiCallback;
import com.gitlab.blockdaemon.ubiquity.invoker.ApiClient;
import com.gitlab.blockdaemon.ubiquity.invoker.ApiException;
import com.gitlab.blockdaemon.ubiquity.invoker.ApiResponse;
import com.gitlab.blockdaemon.ubiquity.invoker.Configuration;
import com.gitlab.blockdaemon.ubiquity.invoker.Pair;
import com.gitlab.blockdaemon.ubiquity.invoker.ProgressRequestBody;
import com.gitlab.blockdaemon.ubiquity.invoker.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.gitlab.blockdaemon.ubiquity.model.Block;
import com.gitlab.blockdaemon.ubiquity.model.BlockIdentifier;
import com.gitlab.blockdaemon.ubiquity.model.Error;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class BlocksApi {
    private ApiClient localVarApiClient;

    public BlocksApi() {
        this(Configuration.getDefaultApiClient());
    }

    public BlocksApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for getBlock
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param key Block number or block hash/ID or Special identifier (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Block </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Invalid Block Number </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockCall(String platform, String network, String key, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/{platform}/{network}/block/{key}"
            .replaceAll("\\{" + "platform" + "\\}", localVarApiClient.escapeString(platform.toString()))
            .replaceAll("\\{" + "network" + "\\}", localVarApiClient.escapeString(network.toString()))
            .replaceAll("\\{" + "key" + "\\}", localVarApiClient.escapeString(key.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/problem+json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getBlockValidateBeforeCall(String platform, String network, String key, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'platform' is set
        if (platform == null) {
            throw new ApiException("Missing the required parameter 'platform' when calling getBlock(Async)");
        }
        
        // verify the required parameter 'network' is set
        if (network == null) {
            throw new ApiException("Missing the required parameter 'network' when calling getBlock(Async)");
        }
        
        // verify the required parameter 'key' is set
        if (key == null) {
            throw new ApiException("Missing the required parameter 'key' when calling getBlock(Async)");
        }
        

        okhttp3.Call localVarCall = getBlockCall(platform, network, key, _callback);
        return localVarCall;

    }

    /**
     * Block By Number/Hash
     * Get a block and all its transactions by the block number or hash
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param key Block number or block hash/ID or Special identifier (required)
     * @return Block
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Block </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Invalid Block Number </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public Block getBlock(String platform, String network, String key) throws ApiException {
        ApiResponse<Block> localVarResp = getBlockWithHttpInfo(platform, network, key);
        return localVarResp.getData();
    }

    /**
     * Block By Number/Hash
     * Get a block and all its transactions by the block number or hash
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param key Block number or block hash/ID or Special identifier (required)
     * @return ApiResponse&lt;Block&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Block </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Invalid Block Number </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Block> getBlockWithHttpInfo(String platform, String network, String key) throws ApiException {
        okhttp3.Call localVarCall = getBlockValidateBeforeCall(platform, network, key, null);
        Type localVarReturnType = new TypeToken<Block>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Block By Number/Hash (asynchronously)
     * Get a block and all its transactions by the block number or hash
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param key Block number or block hash/ID or Special identifier (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Block </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Invalid Block Number </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockAsync(String platform, String network, String key, final ApiCallback<Block> _callback) throws ApiException {

        okhttp3.Call localVarCall = getBlockValidateBeforeCall(platform, network, key, _callback);
        Type localVarReturnType = new TypeToken<Block>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getBlockIdentifier
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param key Block number or block hash/ID or Special identifier (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Block </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Invalid Block Number </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockIdentifierCall(String platform, String network, String key, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/{platform}/{network}/block_identifier/{key}"
            .replaceAll("\\{" + "platform" + "\\}", localVarApiClient.escapeString(platform.toString()))
            .replaceAll("\\{" + "network" + "\\}", localVarApiClient.escapeString(network.toString()))
            .replaceAll("\\{" + "key" + "\\}", localVarApiClient.escapeString(key.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/problem+json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getBlockIdentifierValidateBeforeCall(String platform, String network, String key, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'platform' is set
        if (platform == null) {
            throw new ApiException("Missing the required parameter 'platform' when calling getBlockIdentifier(Async)");
        }
        
        // verify the required parameter 'network' is set
        if (network == null) {
            throw new ApiException("Missing the required parameter 'network' when calling getBlockIdentifier(Async)");
        }
        
        // verify the required parameter 'key' is set
        if (key == null) {
            throw new ApiException("Missing the required parameter 'key' when calling getBlockIdentifier(Async)");
        }
        

        okhttp3.Call localVarCall = getBlockIdentifierCall(platform, network, key, _callback);
        return localVarCall;

    }

    /**
     * Block Identifier By Number/Hash
     * Get minimal block identifier by block number or hash
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param key Block number or block hash/ID or Special identifier (required)
     * @return BlockIdentifier
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Block </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Invalid Block Number </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public BlockIdentifier getBlockIdentifier(String platform, String network, String key) throws ApiException {
        ApiResponse<BlockIdentifier> localVarResp = getBlockIdentifierWithHttpInfo(platform, network, key);
        return localVarResp.getData();
    }

    /**
     * Block Identifier By Number/Hash
     * Get minimal block identifier by block number or hash
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param key Block number or block hash/ID or Special identifier (required)
     * @return ApiResponse&lt;BlockIdentifier&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Block </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Invalid Block Number </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<BlockIdentifier> getBlockIdentifierWithHttpInfo(String platform, String network, String key) throws ApiException {
        okhttp3.Call localVarCall = getBlockIdentifierValidateBeforeCall(platform, network, key, null);
        Type localVarReturnType = new TypeToken<BlockIdentifier>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Block Identifier By Number/Hash (asynchronously)
     * Get minimal block identifier by block number or hash
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param key Block number or block hash/ID or Special identifier (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Block </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Invalid Block Number </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockIdentifierAsync(String platform, String network, String key, final ApiCallback<BlockIdentifier> _callback) throws ApiException {

        okhttp3.Call localVarCall = getBlockIdentifierValidateBeforeCall(platform, network, key, _callback);
        Type localVarReturnType = new TypeToken<BlockIdentifier>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
